Leetcode 300. Longest Increasing Subsequence

来源:互联网 发布:mac 贴膜 涂层脱落 编辑:程序博客网 时间:2024/06/06 02:45

题目:

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

Credits:
Special thanks to @pbrother for adding this problem and creating all test cases.

Subscribe to see which companies asked this question.

思路:

使用动态规划来做,
dp[i]表示到位置i为止,最长递增子序列长度为多少,
那么dp[i] = max(dp[i] ,dp[j]+1)对于所有j( 0< j

代码:

class Solution {public:    int lengthOfLIS(vector<int>& nums) {        int size = nums.size();        if(size == 0) return 0;        vector<int> dp(size, 1);        int res = 1;        for(int i = 1; i < size; ++i) {            for(int j = 0; j < i; ++ j) {                if(nums[i] > nums[j])                    dp[i] = max(dp[i], dp[j] + 1);            }            res = max(res, dp[i]);        }        return res;    }};
原创粉丝点击